import sys, json
from program01 import sillabe
from random import choice, choices, randint

_, modulo, volte, minlen, maxlen = sys.argv
modulo=int(modulo)
volte =int(volte)
minlen=int(minlen)
maxlen=int(maxlen)

vocali    = 'aeioujy'
consonanti= 'bcdfghklmnpqrstvwxz'
interpun  = ".,':;!? "
forbidden = "'ñ\x92\x90\x88æçðñþ"
accentate = 'àáâãäåèéêëìíîïòóôõöøùúûüýÿ'
piane     = 'aaaaaaeeeeiiiioooooouuuuyy'
tran      = str.maketrans(accentate, piane, interpun)

prosodia = choices(range(modulo),k=modulo)
minm = modulo//4
maxm = modulo-minm
while not minm < len(set(prosodia)) < maxm :
    prosodia = choices(range(modulo),k=modulo)

pp = {}
i  = 0
for p in prosodia:
    if p not in pp:
        pp[p] = i
        i += 1
prosodia = [ pp[p] for p in prosodia ]

lengths = { s: randint(minlen,maxlen) for s in set(prosodia) }

def crea_sillaba():
    nv = randint(1, 5)
    nc = randint(1, 5)
    v = choices(vocali + accentate, k=nv)
    c = choices(consonanti, k=nc)
    return ''.join( x.upper() if randint(1,100)<30 else x for x in c+v )

def join_sillabe(pezzi):
    tutto = ( x+choice(interpun) if randint(1, 100)<30 else x for x in pezzi)
    return ''.join( c+' ' if randint(1,100)<30 else c for c in tutto )

rime = {}
versi = []
ultime = []
lunghezze = []
incremento = len(set(prosodia))
for volta in range(volte):
    for i,letter in enumerate(prosodia):
        p = letter+volta*incremento
        if p not in rime:
            rima = crea_sillaba()
            while rima in rime.values():
                rima = crea_sillaba()
            rime[p] = rima
        sillaba = rime[p]
        verso = [sillaba]
        ultime.append(sillaba.lower().translate(tran))
        for _ in range(lengths[letter]-1):
            verso.append(crea_sillaba())
        lunghezze.append(lengths[letter])
        verso.reverse()
        versi.append(verso)
        assert len(verso) == lengths[letter]
        #versi.append(join_sillabe(verso))

testo = '\n'.join(join_sillabe(v) for v in versi)
#print( testo.lower().translate(tran).replace(' ','') )

versi_puliti = [ [ s.lower().translate(tran) for s in v] for v in versi ]

#print(*versi_puliti, sep='\n')

#print(testo)
#print(ultime)
#print(lunghezze)
#print(prosodia)

lang='rnd'
filename = f"secret-{modulo*volte}-{lang}"

with open(f"{filename}.txt", mode='w') as F:
    print(testo, sep='\n', file=F)

test = {
    f"{filename}" : {
        "filename": f"{filename}.txt",
        "prosody":  [ p+incremento*v for v in range(volte) for p in prosodia  ],
        "module":   modulo,
        "lengths":  [ lengths[r] for r in prosodia  ]*volte ,
        "finals":   ultime
    }
}

#print(test)

with open(f"{filename}.json", mode='w') as F:
    json.dump(test,F)
